		CPU	= EZ80F91
		.ORG 0
        .ASSUME ADL=0
		di
		stmix
		jp.lil init
		nop
		nop
		nop
		jp.lil servicecall
		nop
		nop
		nop
		jp.lil nohandler
		nop
		nop
		nop
		jp.lil nohandler
		nop
		nop
		nop
		jp.lil nohandler
		nop
		nop
		nop
		jp.lil nohandler
		nop
		nop
		nop
		jp.lil nohandler
		nop
		nop
		nop
		jp.lil nohandler
		;0x40 - EMAC Rx
		DL nohandler4i
		;0x44 - EMAC Tx
		DL nohandler4i
		;0x48 - EMAC SYS
		DL nohandler4i
		;0x4C -  PLL
		DL nohandler4i
		;0x50 - Flash
		DL nohandler4i
		;0x54 - Timer 0
		DL nohandler4i
		;0x58 - Timer 1
		DL nohandler4i
		;0x5C - Timer 2
		DL nohandler4i
		;0x60 - Timer 3
		DL nohandler4i
		;NMI Handler
		DW 0
		jp.lil nmihandler
		DB 0
		;0x6C -  RTC
		DL nohandler4i
		;0x70 - UART 0
		DL nohandler4i
		;0x74 - UART 1
		DL nohandler4i
		;0x78 -  I2C
		DL nohandler4i
		;0x7C -  SPI
		DL nohandler4i
		;0x80 - Port A 0
		DL nohandler4i
		;0x84 - Port A 1
		DL nohandler4i
		;0x88 - Port A 2
		DL nohandler4i
		;0x8C - Port A 3
		DL nohandler4i
		;0x90 - Port A 4
		DL nohandler4i
		;0x94 - Port A 5
		DL nohandler4i
		;0x98 - Port A 6
		DL nohandler4i
		;0x9C - Port A 7
		DL nohandler4i
		;0xA0 - Port B 0
		DL nohandler4i
		;0xA4 - Port B 1
		DL nohandler4i
		;0xA8 - Port B 2
		DL nohandler4i
		;0xAC - Port B 3
		DL nohandler4i
		;0xB0 - Port B 4
		DL nohandler4i
		;0xB4 - Port B 5
		DL nohandler4i
		;0xB8 - Port B 6
		DL nohandler4i
		;0xBC - Port B 7
		DL nohandler4i
		;0xC0 - Port C 0
		DL nohandler4i
		;0xC4 - Port C 1
		DL nohandler4i
		;0xC8 - Port C 2
		DL nohandler4i
		;0xCC - Port C 3
		DL nohandler4i
		;0xD0 - Port C 4
		DL nohandler4i
		;0xD4 - Port C 5
		DL nohandler4i
		;0xD8 - Port C 6
		DL nohandler4i
		;0xDC - Port C 7
		DL nohandler4i
		;0xE0 - Port D 0
		DL nohandler4i
		;0xE4 - Port D 1
		DL nohandler4i
		;0xE8 - Port D 2
		DL nohandler4i
		;0xEC - Port D 3
		DL nohandler4i
		;0xF0 - Port D 4
		DL nohandler4i
		;0xF4 - Port D 5
		DL nohandler4i
		;0xF8 - Port D 6
		DL nohandler4i
		;0xFC - Port D 7
		DL nohandler4i
        .ASSUME ADL=1
temporarymemory		EQU 0FFF000h
vramstart			EQU 0E42000h
init:
		;Init Chip Selector
		ld a,0c0h
		out0 (0abh),a
		ld a,0ffh
		out0 (0ach),a
		ld a,0bfh
		out0 (0a9h),a
		ld a,008h
		out0 (0adh),a
		;Init Text VRAM
		ld hl,vramstart
		ld (temporarymemory+1),hl
		ld hl,font
		ld de,vramstart-1000h
		ld bc,2048
		ldir
		;unlock the flash to use as the R/W CP/M root disk
		ld a,0b6h
		out0 (0f5h),a
		ld a,49h
		out0 (0f5h),a
		ld a,0fh
		out0 (0fah),a
		;start CP/M
		ld hl,20000h
		ld de,48000h
		ld bc,128
		ldir
		ld a,04h
		ld mb,a
		jp.s 8000h
servicecall:
		ld (temporarymemory),a
		ld a,c
		and a,a
		jr z,crt_const
		cp a,1
		jr z,crt_conin
		cp a,2
		jp z,crt_conout
		ret.l
crt_const:
		ld a,(0e4e005h)
		bit 0,a
		jr nz,crt_const_
		xor a,a
		ret.l
crt_const_:
		ld a,0ffh
		ret.l
crt_conin:
		ld a,(0e4e005h)
		bit 0,a
		jr z,crt_conin
		ld a,(0e4e005h)
		res 0,a
		ld (0e4e005h),a
		ld a,(0e4e004h)
		and a,7fh
		ld (temporarymemory),a
		cp a,16
		jr z,crt_conin_shifted
		cp a,17
		jr z,crt_conin_ctrled
		cp a,65
		jr nc,crt_conin_smalling_1
		cp a,3ch
		jr nc,crt_conin_smalling2_1
crt_conin_l:
		ld (temporarymemory),a
crt_conin_l_:
		ld a,(0e4e005h)
		bit 0,a
		jr nz,crt_conin_l_
		ld a,(temporarymemory)
		ret.l
crt_conin_smalling_1:
		cp a,91
		jr c,crt_conin_smalling_2
		jr crt_conin_l
crt_conin_smalling_2:
		add a,32
		jr crt_conin_l
crt_conin_shifted:
		ld a,(0e4e004h)
		cp a,16
		jr z,crt_conin_shifted
		and a,7fh
		cp a,'@'
		jr nc,crt_conin_shifted_sub32
		cp a,3ch
		jr nc,crt_conin_shifted_bigging_1
crt_conin_shifted_:
		sub a,16
		jr crt_conin_l
crt_conin_shifted_bigging_1:
		cp a,40h
		jr c,crt_conin_l
		jr crt_conin_shifted_
crt_conin_shifted_sub32:
		cp a,96
		jr c,crt_conin_shifted_sub32_1
crt_conin_shifted_sub32_:
		;add a,32
		jr crt_conin_l
crt_conin_shifted_sub32_1:
		cp a,'a'
		jr nc,crt_conin_shifted_sub32_2
		jr crt_conin_shifted_sub32_
crt_conin_shifted_sub32_2:
		sub a,32
		jr crt_conin_l
crt_conin_ctrled:
		ld a,(0e4e004h)
		cp a,17
		jr z,crt_conin_ctrled
		and a,7fh
		sub a,'@'
		jr crt_conin_l
crt_conin_smalling2_1:
		cp a,40h
		jr c,crt_conin_smalling2_2
		jr crt_conin_l
crt_conin_smalling2_2:
		sub a,16
		jr crt_conin_l
crt_conout:
		ld a,(temporarymemory)
		cp a,8
		jr z,crt_conout_bs
		cp a,10
		jr z,crt_conout_lf
		cp a,13
		jr z,crt_conout_cr
		ld hl,(temporarymemory+1)
		ld (hl),a
		inc hl
		ld a,0ffh
		ld (hl),a
		inc hl
		ld (hl),a
		inc hl
		ld (hl),a
		inc hl
		ld (temporarymemory+1),hl
		ld a,h
		sub a,20h
		srl a
		ld hl,(temporarymemory+1)
		cp a,96
		jr nc,crt_conout_lf_
		ret.l
crt_conout_bs:
		ld hl,(temporarymemory+1)
		dec hl
		dec hl
		dec hl
		dec hl
		ld (temporarymemory+1),hl
		ret.l
crt_conout_cr:
		ld hl,(temporarymemory+1)
		ld a,h
		and a,254
		ld h,a
		xor a,a
		ld l,a
		ld (temporarymemory+1),hl
		ret.l
crt_conout_lf:
		ld hl,(temporarymemory+1)
		ld a,h
		sub a,20h
		srl a
		ld hl,(temporarymemory+1)
		cp a,95
		jr nc,crt_conout_lf_
		ld de,512
		add hl,de
		ld (temporarymemory+1),hl
		ret.l
crt_conout_lf_:
		ld hl,vramstart+512
		ld de,vramstart
		ld bc,128*95*4
		ldir
		ld hl,vramstart+(128*95*4)
		ld de,vramstart+(128*95*4)+1
		ld bc,512
		xor a,a
		ld (hl),a
		ldir
		ld hl,vramstart+(128*95*4)
		ld (temporarymemory+1),hl
		ret.l

nohandler4i:
		reti.l
nmihandler:
		retn.l
nohandler:
		ret.l
font:
DB 000h,000h,000h,000h,000h,000h,000h,000h,070h,040h,070h,01Ah,07Ah,00Eh,00Ah,00Ah
DB 070h,040h,070h,012h,074h,008h,014h,022h,070h,040h,070h,042h,074h,008h,014h,022h
DB 070h,040h,070h,040h,07Eh,004h,004h,004h,0E0h,080h,0E0h,08Ch,0F2h,012h,012h,00Dh
DB 020h,050h,070h,052h,054h,018h,014h,012h,070h,048h,070h,048h,074h,004h,004h,007h
DB 070h,048h,070h,04Fh,074h,007h,001h,007h,050h,050h,070h,050h,05Eh,004h,004h,004h
DB 040h,040h,040h,04Eh,078h,00Ch,008h,008h,050h,050h,070h,050h,051h,01Bh,015h,011h
DB 03Ch,040h,040h,044h,038h,008h,008h,00Fh,038h,040h,040h,03Eh,009h,00Eh,00Ah,009h
DB 070h,040h,070h,010h,07Ch,012h,012h,00Ch,070h,040h,070h,010h,07Eh,004h,004h,00Eh
DB 070h,048h,048h,04Fh,074h,007h,004h,007h,070h,048h,048h,04Ah,076h,002h,002h,007h
DB 070h,048h,048h,04Eh,071h,006h,008h,00Fh,070h,048h,048h,04Fh,071h,007h,001h,00Fh
DB 070h,048h,048h,04Ah,076h,00Ah,01Fh,002h,048h,068h,058h,049h,04Ah,00Ch,00Ah,009h
DB 070h,040h,070h,010h,079h,00Dh,00Bh,009h,070h,040h,070h,04Eh,079h,00Eh,009h,00Eh
DB 038h,040h,040h,038h,009h,00Dh,00Bh,009h,070h,040h,070h,040h,071h,01Bh,015h,011h
DB 070h,040h,070h,01Ch,072h,01Ch,012h,01Ch,070h,040h,070h,040h,07Eh,010h,010h,00Eh
DB 000h,008h,004h,07Eh,004h,008h,000h,000h,000h,010h,020h,07Eh,020h,010h,000h,000h
DB 000h,008h,01Ch,02Ah,008h,008h,008h,000h,000h,008h,008h,008h,02Ah,01Ch,008h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,008h,008h,008h,008h,000h,000h,008h,000h
DB 024h,024h,024h,000h,000h,000h,000h,000h,024h,024h,07Eh,024h,07Eh,024h,024h,000h
DB 008h,01Eh,028h,01Ch,00Ah,03Ch,008h,000h,000h,062h,064h,008h,010h,026h,046h,000h
DB 030h,048h,048h,030h,04Ah,044h,03Ah,000h,004h,008h,010h,000h,000h,000h,000h,000h
DB 004h,008h,010h,010h,010h,008h,004h,000h,020h,010h,008h,008h,008h,010h,020h,000h
DB 008h,02Ah,01Ch,03Eh,01Ch,02Ah,008h,000h,000h,008h,008h,03Eh,008h,008h,000h,000h
DB 000h,000h,000h,000h,000h,008h,008h,010h,000h,000h,000h,07Eh,000h,000h,000h,000h
DB 000h,000h,000h,000h,000h,018h,018h,000h,000h,002h,004h,008h,010h,020h,040h,000h
DB 03Ch,042h,046h,05Ah,062h,042h,03Ch,000h,008h,018h,028h,008h,008h,008h,03Eh,000h
DB 03Ch,042h,002h,00Ch,030h,040h,07Eh,000h,03Ch,042h,002h,01Ch,002h,042h,03Ch,000h
DB 004h,00Ch,014h,024h,07Eh,004h,004h,000h,07Eh,040h,078h,004h,002h,044h,038h,000h
DB 01Ch,020h,040h,07Ch,042h,042h,03Ch,000h,07Eh,042h,004h,008h,010h,010h,010h,000h
DB 03Ch,042h,042h,03Ch,042h,042h,03Ch,000h,03Ch,042h,042h,03Eh,002h,004h,038h,000h
DB 000h,000h,008h,000h,000h,008h,000h,000h,000h,000h,008h,000h,000h,008h,008h,010h
DB 00Eh,018h,030h,060h,030h,018h,00Eh,000h,000h,000h,07Eh,000h,07Eh,000h,000h,000h
DB 070h,018h,00Ch,006h,00Ch,018h,070h,000h,03Ch,042h,002h,00Ch,010h,000h,010h,000h
DB 01Ch,022h,04Ah,056h,04Ch,020h,01Eh,000h,018h,024h,042h,07Eh,042h,042h,042h,000h
DB 07Ch,022h,022h,03Ch,022h,022h,07Ch,000h,01Ch,022h,040h,040h,040h,022h,01Ch,000h
DB 078h,024h,022h,022h,022h,024h,078h,000h,07Eh,040h,040h,078h,040h,040h,07Eh,000h
DB 07Eh,040h,040h,078h,040h,040h,040h,000h,01Ch,022h,040h,04Eh,042h,022h,01Ch,000h
DB 042h,042h,042h,07Eh,042h,042h,042h,000h,01Ch,008h,008h,008h,008h,008h,01Ch,000h
DB 00Eh,004h,004h,004h,004h,044h,038h,000h,042h,044h,048h,070h,048h,044h,042h,000h
DB 040h,040h,040h,040h,040h,040h,07Eh,000h,042h,066h,05Ah,05Ah,042h,042h,042h,000h
DB 042h,062h,052h,04Ah,046h,042h,042h,000h,018h,024h,042h,042h,042h,024h,018h,000h
DB 07Ch,042h,042h,07Ch,040h,040h,040h,000h,018h,024h,042h,042h,04Ah,024h,01Ah,000h
DB 07Ch,042h,042h,07Ch,048h,044h,042h,000h,03Ch,042h,040h,03Ch,002h,042h,03Ch,000h
DB 03Eh,008h,008h,008h,008h,008h,008h,000h,042h,042h,042h,042h,042h,042h,03Ch,000h
DB 042h,042h,042h,024h,024h,018h,018h,000h,042h,042h,042h,05Ah,05Ah,066h,042h,000h
DB 042h,042h,024h,018h,024h,042h,042h,000h,022h,022h,022h,01Ch,008h,008h,008h,000h
DB 07Eh,002h,004h,018h,020h,040h,07Eh,000h,03Ch,020h,020h,020h,020h,020h,03Ch,000h
DB 022h,022h,014h,03Eh,008h,03Eh,008h,000h,03Ch,004h,004h,004h,004h,004h,03Ch,000h
DB 008h,014h,022h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,07Eh,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,03Ch,004h,03Ch,044h,03Ah,000h
DB 040h,040h,05Ch,062h,042h,062h,05Ch,000h,000h,000h,03Ch,042h,040h,042h,03Ch,000h
DB 002h,002h,03Ah,046h,042h,046h,03Ah,000h,000h,000h,03Ch,042h,07Eh,040h,03Ch,000h
DB 00Ch,012h,010h,07Ch,010h,010h,010h,000h,000h,000h,03Ah,046h,046h,03Ah,002h,03Ch
DB 040h,040h,05Ch,062h,042h,042h,042h,000h,008h,000h,018h,008h,008h,008h,01Ch,000h
DB 004h,000h,00Ch,004h,004h,004h,044h,038h,040h,040h,044h,048h,050h,068h,044h,000h
DB 018h,008h,008h,008h,008h,008h,01Ch,000h,000h,000h,076h,049h,049h,049h,049h,000h
DB 000h,000h,05Ch,062h,042h,042h,042h,000h,000h,000h,03Ch,042h,042h,042h,03Ch,000h
DB 000h,000h,05Ch,062h,062h,05Ch,040h,040h,000h,000h,03Ah,046h,046h,03Ah,002h,002h
DB 000h,000h,05Ch,062h,040h,040h,040h,000h,000h,000h,03Eh,040h,03Ch,002h,07Ch,000h
DB 010h,010h,07Ch,010h,010h,012h,00Ch,000h,000h,000h,042h,042h,042h,046h,03Ah,000h
DB 000h,000h,042h,042h,042h,024h,018h,000h,000h,000h,041h,049h,049h,049h,036h,000h
DB 000h,000h,042h,024h,018h,024h,042h,000h,000h,000h,042h,042h,046h,03Ah,002h,03Ch
DB 000h,000h,07Eh,004h,018h,020h,07Eh,000h,00Eh,010h,010h,020h,010h,010h,00Eh,000h
DB 008h,008h,000h,000h,000h,008h,008h,000h,070h,008h,008h,004h,008h,008h,070h,000h
DB 030h,049h,006h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
DB 000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h,000h,000h,000h,000h,0FFh,0FFh
DB 000h,000h,000h,000h,000h,0FFh,0FFh,0FFh,000h,000h,000h,000h,0FFh,0FFh,0FFh,0FFh
DB 000h,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh,000h,000h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
DB 000h,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh
DB 080h,080h,080h,080h,080h,080h,080h,080h,0C0h,0C0h,0C0h,0C0h,0C0h,0C0h,0C0h,0C0h
DB 0E0h,0E0h,0E0h,0E0h,0E0h,0E0h,0E0h,0E0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h,0F0h
DB 0F8h,0F8h,0F8h,0F8h,0F8h,0F8h,0F8h,0F8h,0FCh,0FCh,0FCh,0FCh,0FCh,0FCh,0FCh,0FCh
DB 0FEh,0FEh,0FEh,0FEh,0FEh,0FEh,0FEh,0FEh,008h,008h,008h,008h,0FFh,008h,008h,008h
DB 008h,008h,008h,008h,0FFh,000h,000h,000h,000h,000h,000h,000h,0FFh,008h,008h,008h
DB 008h,008h,008h,008h,0F8h,008h,008h,008h,008h,008h,008h,008h,00Fh,008h,008h,008h
DB 0FFh,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0FFh,000h,000h,000h
DB 008h,008h,008h,008h,008h,008h,008h,008h,001h,001h,001h,001h,001h,001h,001h,001h
DB 000h,000h,000h,000h,00Fh,008h,008h,008h,000h,000h,000h,000h,0F8h,008h,008h,008h
DB 008h,008h,008h,008h,00Fh,000h,000h,000h,008h,008h,008h,008h,0F8h,000h,000h,000h
DB 000h,000h,000h,000h,003h,004h,008h,008h,000h,000h,000h,000h,0E0h,010h,008h,008h
DB 008h,008h,008h,004h,003h,000h,000h,000h,008h,008h,008h,010h,0E0h,000h,000h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,038h,028h,038h,000h
DB 01Ch,010h,010h,010h,000h,000h,000h,000h,000h,000h,000h,008h,008h,008h,038h,000h
DB 000h,000h,000h,000h,020h,010h,008h,000h,000h,000h,000h,018h,018h,000h,000h,000h
DB 000h,07Eh,002h,07Eh,002h,004h,038h,000h,000h,000h,03Eh,002h,00Ch,008h,010h,000h
DB 000h,000h,004h,008h,018h,028h,008h,000h,000h,000h,008h,03Eh,022h,002h,00Ch,000h
DB 000h,000h,000h,03Eh,008h,008h,03Eh,000h,000h,000h,004h,03Eh,00Ch,014h,024h,000h
DB 000h,000h,010h,03Eh,012h,014h,010h,000h,000h,000h,000h,01Ch,004h,004h,03Eh,000h
DB 000h,000h,03Ch,004h,03Ch,004h,03Ch,000h,000h,000h,000h,02Ah,02Ah,002h,00Ch,000h
DB 000h,000h,000h,03Eh,000h,000h,000h,000h,07Eh,002h,002h,014h,018h,010h,020h,000h
DB 002h,004h,008h,018h,028h,048h,008h,000h,008h,07Eh,042h,042h,002h,004h,038h,000h
DB 000h,03Eh,008h,008h,008h,008h,03Eh,000h,008h,07Eh,008h,018h,028h,048h,008h,000h
DB 010h,07Eh,012h,012h,012h,012h,024h,000h,008h,03Eh,008h,03Eh,008h,008h,008h,000h
DB 01Eh,022h,042h,004h,008h,010h,060h,000h,020h,03Eh,048h,008h,008h,008h,010h,000h
DB 000h,07Eh,002h,002h,002h,002h,07Eh,000h,024h,07Eh,024h,024h,004h,008h,010h,000h
DB 000h,070h,000h,072h,002h,004h,078h,000h,07Eh,002h,004h,008h,018h,024h,042h,000h
DB 020h,07Eh,022h,024h,020h,020h,01Eh,000h,042h,042h,022h,002h,004h,008h,030h,000h
DB 01Eh,022h,062h,014h,008h,010h,060h,000h,004h,038h,008h,07Eh,008h,008h,070h,000h
DB 000h,052h,052h,052h,004h,008h,070h,000h,03Ch,000h,07Eh,008h,008h,010h,020h,000h
DB 010h,010h,010h,018h,014h,010h,010h,000h,008h,008h,07Eh,008h,008h,010h,020h,000h
DB 000h,03Ch,000h,000h,000h,000h,07Eh,000h,000h,03Eh,002h,014h,008h,014h,020h,000h
DB 008h,03Eh,004h,008h,01Ch,02Ah,008h,000h,002h,002h,002h,004h,008h,010h,020h,000h
DB 010h,008h,004h,042h,042h,042h,042h,000h,040h,040h,07Eh,040h,040h,040h,03Eh,000h
DB 000h,07Eh,002h,002h,004h,008h,030h,000h,000h,010h,028h,044h,002h,002h,000h,000h
DB 008h,03Eh,008h,008h,02Ah,02Ah,008h,000h,07Eh,002h,002h,004h,028h,010h,008h,000h
DB 000h,03Ch,000h,03Ch,000h,07Ch,002h,000h,004h,008h,010h,020h,048h,07Ch,002h,000h
DB 000h,002h,002h,014h,008h,014h,060h,000h,000h,07Eh,010h,07Eh,010h,010h,01Eh,000h
DB 020h,020h,07Eh,022h,024h,020h,020h,000h,000h,038h,008h,008h,008h,008h,07Eh,000h
DB 07Eh,002h,002h,07Eh,002h,002h,07Eh,000h,03Ch,000h,07Eh,002h,004h,008h,010h,000h
DB 042h,042h,042h,042h,002h,004h,018h,000h,028h,028h,028h,02Ah,02Ah,02Ch,048h,000h
DB 020h,020h,020h,022h,024h,028h,030h,000h,000h,07Eh,042h,042h,042h,042h,07Eh,000h
DB 000h,07Eh,042h,042h,002h,004h,018h,000h,000h,070h,002h,002h,004h,008h,070h,000h
DB 010h,048h,020h,000h,000h,000h,000h,000h,070h,050h,070h,000h,000h,000h,000h,000h
DB 000h,000h,0FFh,000h,000h,0FFh,000h,000h,008h,008h,00Fh,008h,008h,00Fh,008h,008h
DB 008h,008h,0FFh,008h,008h,0FFh,008h,008h,008h,008h,0F8h,008h,008h,0F8h,008h,008h
DB 001h,003h,007h,00Fh,01Fh,03Fh,07Fh,0FFh,080h,0C0h,0E0h,0F0h,0F8h,0FCh,0FEh,0FFh
DB 0FFh,07Fh,03Fh,01Fh,00Fh,007h,003h,001h,0FFh,0FEh,0FCh,0F8h,0F0h,0E0h,0C0h,080h
DB 008h,01Ch,03Eh,07Fh,07Fh,01Ch,03Eh,000h,036h,07Fh,07Fh,07Fh,03Eh,01Ch,008h,000h
DB 008h,01Ch,03Eh,07Fh,03Eh,01Ch,008h,000h,01Ch,01Ch,07Fh,07Fh,06Bh,008h,03Eh,000h
DB 000h,03Ch,07Eh,07Eh,07Eh,07Eh,03Ch,000h,000h,03Ch,042h,042h,042h,042h,03Ch,000h
DB 001h,002h,004h,008h,010h,020h,040h,080h,080h,040h,020h,010h,008h,004h,002h,001h
DB 081h,042h,024h,018h,018h,024h,042h,081h,07Fh,049h,049h,07Fh,041h,041h,041h,000h
DB 040h,07Eh,048h,03Ch,028h,07Eh,008h,000h,03Fh,021h,03Fh,021h,03Fh,021h,041h,000h
DB 07Fh,041h,041h,07Fh,041h,041h,07Fh,000h,004h,0EEh,0A4h,0EFh,0A2h,0EFh,00Ah,002h
DB 000h,018h,024h,042h,03Ch,014h,024h,000h,03Ah,012h,07Fh,017h,03Bh,052h,014h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
DB 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h

		END
